<?php

class Admin {

	public static function reinstall_bd($file = '') {
		
		global $def;
		
		return self::install_bd($file, true);
	}
	
	public static function install_bd($file = '', $force = false) {
		
		global $def;
		if (!$file) $file = $def['sql_tables'];
		$farr = get_file_arr($file);
		if (!isset($farr['text']) || !trim($farr['text'])) return exit('no file or empty ' . $file);
		$sql = $farr['text'];
		
		$prefix = esse($def, 'mysql', 'table_prefix');
		if ($prefix) {
			$sql = str_replace('if not exists `', 'if not exists `' . $prefix, $sql);
			$sql = str_replace('insert ignore into `', 'insert ignore into `' . $prefix, $sql);
		}
		
		if ($force) {
			$sql = preg_replace("/(CREATE TABLE if not exists \`([^`]+)\`)/i", 'DROP TABLE if exists `$2`;' . CR . '$1', $sql);
		}
		$sql = preg_replace("/\/\*[\s\S]*?\*\//", '', $sql);
		$arr = self::split_sql($sql);
		//exit('<pre>' . $arr[0]);
		
		$cnn = Mysql::connect($def['mysql']);
		if (!$cnn) return 'no connection';
		$str = '';
		foreach($arr as $v) {
			if (strlen(trim($v)) > 4) $str .= self::work_sql($v);
		}
		return '<pre>' . $str . '</pre>';
		
	}
	
	private static function split_sql($sql) {
		
		$div = "/\;\r?\n/";
		return preg_split($div, $sql);
	}
	
	private static function work_sql($sql){
		$r = mysql_query($sql);
		$err = mysql_error();
		$inf = '';
		if (is_resource($r)) {
			$n = mysql_num_rows($r);
		}
		else {
			$n = mysql_affected_rows();
			$inf .= mysql_info();
		}
		$sqltext = def_e(substr($sql, 0, 100));
		return "Запрос ($sqltext ...): затронуто строк $n; $inf; $err\n";
	}
	
}