<?php

class Controller {

	public function __construct() {
/**
* Примерная схема url:
* .htm - "статика" из таблицы texts (например, страница "О компании"), абстрактная Сущность "Страница" или "Текст"
* .com - действия с данными на сервере (как правило, своего отображения нет, только ошибки, а если ошибок нет, перенаправление на referer), работает только с POST (и GET - для аякса?) запросами
* .aspx - статья с комментариями (? - комментарии могут быть и у .htm)
* .asp - комментарии отдельно
* .html - для "сущностей" из разных таблиц (например, товаров), хотя пока неясно, зачем
*/
		global $def;
		$this->set_url();
		$meta = $def['meta'];
		
		if (!isset($meta[$def['subj']])) exit(def_404());
		
		$test_com = explode('.', $def['subj']);
		$ext = array_pop($test_com);
		if ($ext == 'com') {
			$action = implode('.', $test_com);
			$def['subj'] = esse($_POST, 'subj');
			if ($def['subj']) View::$action($def['subj']);
			else exit(def_404('!POST[com-action]'));
		}
		else {
			$def['id'] = (isset($_GET['id'])) ? intval($_GET['id']) : null;
			$view = esse($meta[$def['subj']], 'view');
			
			new View($def['subj'], $def['id'], $view);
		}
	}
	
	private function set_url() {
		
		global $def;
		$url = $def['env']['uri'];
		$url = preg_split("/\?/", $url);
		$url = $url[0];
		$url = explode('/', $url);
		$url = array_pop($url);
		if (!$url) $url = $def['default_url'];
		
		$re = preg_quote($def['ext'], '/');
		$subj = preg_replace("/{$re}$/", '', $url);
		$def['file'] = $url;
		$def['subj'] = $subj;
	}
	
}