<?php

error_reporting(E_ALL);
ini_set('display_errors', true);
setlocale(LC_ALL, 'ru_RU.cp1251');
date_default_timezone_set('Asia/Irkutsk');

$def = array('site_path' => dirname(__FILE__)); 
$def['lib'] = $def['site_path'] . '/../lib';
define('CR', "\n");

new Config();

new Controller();

function __autoload($class) {
	global $def;
	if (empty($def['lib'])) return;
	$file = $def['lib'] . '/' . $class . '.php';
	if (file_exists($file)) require_once $file;
}

function def_404($str = '') {
	header('HTTP/1.x 404 Not Found');
	exit('<center><strong><br><br>404: страница не найдена
<br>' . $str . '<br> <a href="./">Главная</a> ');
}

function esse(&$array)
{
	$args = func_get_args();
	$arr = array_shift($args);
	if (empty($arr)) return '';
	
	foreach($args as $key) {
		if (empty($key) && 0 !== $key) return $arr;
		if (!is_array($arr)) return ''; //Внимание, важно: если у не-массива запрошен ключ!!
		if (empty($arr[$key])) return '';
		$arr = $arr[$key];
	}
	
	return $arr;
}

function def_e($x) {
	$in = array('"', "'", '<');
	$out = array('&#34;', "&#39;", '&lt;');
	return str_replace($in, $out, $x);
}

function get_file_arr($path) {
	$file = array();
	if (!file_exists($path)) return $file;
	$file['time'] = filemtime($path);
	$file['text'] = implode(file($path));
	return($file);
}
